﻿'******************************
' アメダスデータダウンローダ
'
'  アメダスの気象データをダウンロードするプログラムです。
'
' [開発者]　Katsuhiro Morishita (Kumamoto-university Japan)
' [開発履歴]
'     2012/8/22   コマンドライン版の方が融通が効くので、整備することにした。
'     2012/11/22  先日より進めていたアメダス関連クラスの更新とデバッグを終えた。
'                 保存文字コードと読み込みコードをUTF-8へ統一した。
' *****************************
Imports System
Imports System.IO
Imports System.Text
Imports System.Text.RegularExpressions

Module Module1

    Sub Main()
        Dim i As Integer
        Dim t As Date
        Dim url As String = ""
        Dim fname, path As String
        Dim target As AmedasSetting = New AmedasSetting

        If target.IsOpen Then

            t = target.StartDate                                                            ' 初日の日付を取得
            While t <= target.StopDate                                                      ' 設定日までループ
                For i = 0 To target.Length - 1                                              ' 指定された全ての地点をループで処理
                    Console.WriteLine("Now target: " + t.ToString + ", " + target.GetInformation(i).name)

                    url = target.GetURL_10min(t, i)                                         ' URL作成
                    path = target.CreateDirectory4rawHtmls(t, i)                            ' 保存用のディレクトリ作成及びそこまでのパスを取得

                    Dim wc As New Net.WebClient()                                           ' ファイルダウンロードの準備
                    Using st As Stream = wc.OpenRead(url)                                   ' 指定URLへアクセスしてオブジェクトをゲット
                        'Dim sr As New StreamReader(st, Encoding.GetEncoding("Shift_JIS"))   ' ダウンロードしたhtmlの文字コードを指定
                        Dim sr As New StreamReader(st, Encoding.UTF8)                       ' ダウンロードしたhtmlの文字コードを指定
                        fname = target.GetFileName4Html(t, i)                               ' ファイル名生成
                        Using sw As New System.IO.StreamWriter(path + "/" + fname, False, System.Text.Encoding.UTF8)
                        'Using sw As New System.IO.StreamWriter(path + "/" + fname, False, System.Text.Encoding.GetEncoding("shift_jis"))    ' ファイル出力準備
                            sw.Write(sr.ReadToEnd)                                          ' ファイルへ保存
                        End Using
                    End Using
                    System.Threading.Thread.Sleep(1000)                                     ' サーバー負荷を避けるために無駄時間待つ
                Next
                t = t.AddDays(1)                                                            ' 日付を加算
            End While

        End If
    End Sub

End Module
